struct qstr {
	const unsigned char * name;/* this has to be d_iname */
	unsigned int len;
	unsigned int hash;
};

struct dentry {
  struct inode * d_inode;
  struct qstr d_name;
  unsigned char d_iname[256];
};

struct pipe_inode_info {
  int reserved;
};

/*#include "../kernel-include/reiserfs_fs_i.h"*/
#include "reiserfs_fs_i.h"

struct semaphore {
};

struct inode {
  struct super_block * i_sb;
  struct inode_operations * i_op;
  unsigned long i_blksize;
  unsigned long	i_blocks;
  unsigned int i_flags;
  unsigned int i_count;
  int i_dirt;
  kdev_t i_dev;
  off_t i_size;
  unsigned long i_ino;
  umode_t i_mode;
  time_t i_mtime;
  time_t i_ctime;
  time_t i_atime;
  uid_t	i_uid;
  gid_t	i_gid;
  nlink_t i_nlink;
  kdev_t i_rdev;
  struct semaphore i_sem;
  struct inode * i_next;
  struct inode * i_prev;
  union {
    struct reiserfs_inode_info reiserfs_i;
  } u;
};
#define CURRENT_TIME 0

#define mark_inode_dirty(inode) ((inode)->i_dirt = 1)


struct file {
  struct dentry	* f_dentry;
  unsigned int f_flags;
  loff_t f_pos;
  struct file_operations * f_op;
};

struct iattr {
};

struct page {
  int offset;
  int count;
  int flags;
};
#define PG_uptodate 1

typedef int (*filldir_t)(void *, const char *, int, off_t, ino_t);

struct vm_area_struct {
};

struct file_operations {
  int *llseek;
  ssize_t (*read) (struct file *, char *, size_t, loff_t *);
  ssize_t (*write) (struct file *, const char *, size_t, loff_t *);
  int (*readdir) (struct file *, void *, filldir_t);
  int *poll;
  int *ioctl;
  int (*mmap) (struct file *, struct vm_area_struct *);
  int *open;
  int *flush;
  int *release;
  int (*fsync) (struct file *, struct dentry *);
  int *fasync;
  int *check_media_change;
  int *revalidate;
  int *lock;
};


extern int generic_file_mmap(struct file *, struct vm_area_struct *);
struct inode_operations {
  struct file_operations * default_file_ops;
  int (*create) (struct inode *,struct dentry *,int);
  int (*lookup) (struct inode *,struct dentry *);
  int (*link) (struct dentry *,struct inode *,struct dentry *);
  int (*unlink) (struct inode *,struct dentry *);
  int (*symlink) (struct inode *,struct dentry *,const char *);
  int (*mkdir) (struct inode *,struct dentry *,int);
  int (*rmdir) (struct inode *,struct dentry *);
  int (*mknod) (struct inode *,struct dentry *,int,int);
  int (*rename) (struct inode *, struct dentry *,
		 struct inode *, struct dentry *);
  int (*readlink) (struct dentry *, char *,int);
  struct dentry * (*follow_link) (struct dentry *, struct dentry *, unsigned int);
  int (*readpage) (struct file *, struct page *);
  int *writepage;
  int (*bmap) (struct inode *,int);
  void (*truncate) (struct inode *);
  int (*permission) (struct inode *, int);
  int *smap;
  int *updatepage;
  int *revalidate;
};




/* inode.c */
void insert_inode_hash (struct inode * inode);
struct inode * get_empty_inode (void);
struct inode * iget (struct super_block *sb, unsigned long ino);
void iput (struct inode * inode);
int generic_readpage(struct file * file, struct page * page);
void sync_inodes (void);
