#include "nokernel.h"


void die (char * fmt, ...);
void * getmem (int size);
void freemem (void * p, int size);

/*
void decrement_bcount (struct buffer_head * bh)
{
  brelse (bh);
}
*/
/*
void decrement_counters_in_path (struct path * path)
{
  int offset = path->path_length;

  if (offset < ILLEGAL_PATH_ELEMENT_OFFSET )
    die ("decrement_counters_in_path: illegal path offset");

  while (offset > ILLEGAL_PATH_ELEMENT_OFFSET)
    decrement_bcount(PATH_OFFSET_PBUFFER(path, offset--));
  path->path_length = ILLEGAL_PATH_ELEMENT_OFFSET;
}

void  pathrelse (struct path * path)
{
  decrement_counters_in_path (path);
}
*/

void remove_from_buffer_list (struct buffer_head * bh);/* io.c */
void put_buffer_list_head (struct buffer_head * bh);/* io.c */
/*
int test_and_wait_on_buffer (struct buffer_head * bh)
{
  return CARRY_ON;
}
*/

extern struct super_operations reiserfs_sops;
void read_super_block (int dev, struct super_block * s)
{
  struct buffer_head * bh;
  struct reiserfs_super_block * rsb;

  bh = bread (dev, REISERFS_FIRST_BLOCK, 1024);
  rsb = (struct reiserfs_super_block *)bh->b_data;
  if (strncmp (rsb->s_magic, REISERFS_SUPER_MAGIC, strlen (REISERFS_SUPER_MAGIC)))
    die ("read_super_block: can't find a reiser filesystem on dev %x\n", dev);
  s->s_dev = dev;
  s->s_blocksize = rsb->s_blocksize;
  SB_BUFFER_WITH_SB (s) = bread (dev, (REISERFS_FIRST_BLOCK * 1024) / s->s_blocksize, s->s_blocksize);
  SB_DISK_SUPER_BLOCK (s) = (struct reiserfs_super_block *)(SB_BUFFER_WITH_SB (s)->b_data);

  if (strncmp (SB_REISERFS_MAGIC (s), REISERFS_SUPER_MAGIC, strlen (REISERFS_SUPER_MAGIC)))
    die ("read_super_block: reiser filesystem lost on dev %x\n", dev);
  brelse (bh);
  s->s_op = &reiserfs_sops;
}


static void read_bitmap (struct super_block * s, struct buffer_head *** bhs, char *** bdatas, int first)
{
  int j;
  int reserved_block_nr;

  reserved_block_nr = (REISERFS_FIRST_BLOCK * 1024) / s->s_blocksize;

  if (*bhs == 0)
    *bhs = getmem (sizeof (struct buffer_head *) * SB_BMAP_NR (s));
  if (*bdatas == 0)
    *bdatas = getmem (sizeof (char *) * SB_BMAP_NR (s));
  for (j = 0; j < SB_BMAP_NR (s); j ++) {
    (*bhs)[j] = bread (s->s_dev, j + reserved_block_nr + 1 + first, s->s_blocksize);
    (*bdatas)[j] = (*bhs)[j]->b_data;
  }
}


void read_true_bitmap (struct super_block * s, struct buffer_head *** bhs, char *** bdatas)
{
  read_bitmap (s, bhs, bdatas, 0);
}


void read_cautious_bitmap (struct super_block * s, struct buffer_head *** bhs, char *** bdatas)
{
  read_bitmap (s, bhs, bdatas, SB_BMAP_NR (s));
}


